class MSBGame extends GameInfo
config;

#exec OBJ LOAD FILE=MovieSandboxMeshes.usx
#exec OBJ LOAD FILE=MovieSandboxTextures.utx


var name startStateName;

static function PrecacheGameStaticMeshes(LevelInfo myLevel)
{
super.PrecacheGameStaticMeshes(myLevel);
myLevel.AddPrecacheStaticMesh(StaticMesh'MoviesandboxMeshes.helperMeshes.CubeWhite');
}

static function PrecacheGameTextures(LevelInfo myLevel)
{
super.PrecacheGameTextures(myLevel);
myLevel.AddPrecacheMaterial(Material'MovieSandboxTextures.white');
}

//somewhere here, the Savegamefunction gets fucked up!!!
event PlayerController Login
(
    string Portal,
    string Options,
    out string Error
)
{
    local NavigationPoint StartSpot;
    local PlayerController NewPlayer, TestPlayer;
    local string          InName, InAdminName, InPassword, InChecksum, InCharacter,InSex;
    local byte            InTeam;
    local bool bSpectator, bAdmin;
    local class<Security> MySecurityClass;
    local pawn TestPawn;

	Options = StripColor(Options);	// Strip out color Codes

    // Get URL options.
    InName     = Left(ParseOption ( Options, "Name"), 20);
    InTeam     = GetIntOption( Options, "Team", 255 ); // default to "no team"
    InAdminName= ParseOption ( Options, "AdminName");
    InPassword = ParseOption ( Options, "Password" );
    InChecksum = ParseOption ( Options, "Checksum" );

	if ( HasOption(Options, "Load") )
	{
		log("Loading Savegame");

		InitSavedLevel();
		bIsSaveGame = true;

		// Try to match up to existing unoccupied player in level,
		// for savegames - also needed coop level switching.
		ForEach DynamicActors(class'PlayerController', TestPlayer )
		{
			if ( (TestPlayer.Player==None) && (TestPlayer.PlayerOwnerName~=InName) )
			{
				TestPawn = TestPlayer.Pawn;
				if ( TestPawn != None )
					TestPawn.SetRotation(TestPawn.Controller.Rotation);
log("FOUND "$TestPlayer@TestPlayer.PlayerReplicationInfo.PlayerName);
				return TestPlayer;
			}
		}
	}

    bSpectator = ( ParseOption( Options, "SpectatorOnly" ) ~= "1" );
    if (AccessControl != None)
		bAdmin = AccessControl.CheckOptionsAdmin(Options);

    // Make sure there is capacity except for admins. (This might have changed since the PreLogin call).
    if ( !bAdmin && AtCapacity(bSpectator) )
    {
        Error = GameMessageClass.Default.MaxedOutMessage;
        return None;
    }

	// If admin, force spectate mode if the server already full of reg. players
	if ( bAdmin && AtCapacity(false))
		bSpectator = true;

    BaseMutator.ModifyLogin(Portal, Options);

    // Pick a team (if need teams)
    InTeam = PickTeam(InTeam,None);

    // Find a start spot.
    StartSpot = FindPlayerStart( None, InTeam, Portal );

    if( StartSpot == None )
    {
        Error = GameMessageClass.Default.FailedPlaceMessage;
        return None;
    }

    if ( PlayerControllerClass == None )
        PlayerControllerClass = class<PlayerController>(DynamicLoadObject(PlayerControllerClassName, class'Class'));

    NewPlayer = spawn(PlayerControllerClass,,,StartSpot.Location,StartSpot.Rotation);

    // Handle spawn failure.
    if( NewPlayer == None )
    {
        log("Couldn't spawn player controller of class "$PlayerControllerClass);
        Error = GameMessageClass.Default.FailedSpawnMessage;
        return None;
    }

    NewPlayer.StartSpot = StartSpot;

    // Init player's replication info
    NewPlayer.GameReplicationInfo = GameReplicationInfo;

	// Apply security to this controller
	MySecurityClass=class<Security>(DynamicLoadObject(SecurityClass,class'class'));
    if (MySecurityClass!=None)
    {
		NewPlayer.PlayerSecurity = spawn(MySecurityClass,NewPlayer);
		if (NewPlayer.PlayerSecurity==None)
			log("Could not spawn security for player "$NewPlayer,'Security');
    }
    else if (SecurityClass == "")
    	log("No value for Engine.GameInfo.SecurityClass -- System is not secure.",'Security');
    else
	    log("Unknown security class ["$SecurityClass$"] -- System is not secure.",'Security');

	if ( bAttractCam )
		NewPlayer.GotoState('AttractMode');
	else
		NewPlayer.GotoState('Spectating');

    // Init player's name
    if( InName=="" )
        InName=DefaultPlayerName;
    if( Level.NetMode!=NM_Standalone || NewPlayer.PlayerReplicationInfo.PlayerName==DefaultPlayerName )
        ChangeName( NewPlayer, InName, false );

	// custom voicepack
    NewPlayer.PlayerReplicationInfo.VoiceTypeName = ParseOption ( Options, "Voice");

    InCharacter = ParseOption(Options, "Character");
    NewPlayer.SetPawnClass(DefaultPlayerClassName, InCharacter);
    InSex = ParseOption(Options, "Sex");
    if ( Left(InSex,3) ~= "F" )
		NewPlayer.SetPawnFemale();	// only effective if character not valid

    // Set the player's ID.
    NewPlayer.PlayerReplicationInfo.PlayerID = CurrentID++;

    if ( bSpectator || NewPlayer.PlayerReplicationInfo.bOnlySpectator || !ChangeTeam(newPlayer, InTeam, false) )
    {
        NewPlayer.PlayerReplicationInfo.bOnlySpectator = true;
        NewPlayer.PlayerReplicationInfo.bIsSpectator = true;
        NewPlayer.PlayerReplicationInfo.bOutOfLives = true;
        NumSpectators++;

        NewPlayer.GotoState(startStateName);
        return NewPlayer;
    }

	newPlayer.StartSpot = StartSpot;

    // Init player's administrative privileges and log it
    if (AccessControl != None && AccessControl.AdminLogin(NewPlayer, InAdminName, InPassword))
    {
		AccessControl.AdminEntered(NewPlayer, InAdminName);
    }

    NumPlayers++;
    bWelcomePending = true;

	if ( bTestMode )
		TestLevel();

    // if delayed start, don't give a pawn to the player yet
    // Normal for multiplayer games

    NewPlayer.GotoState(startStateName);
    return newPlayer;
}

defaultproperties
{
startStateName=MSBCode
HUDType="MSBCode.MSBSceneEditorHud"
PlayerControllerClassName="MSBCode.MSBController"

bLoggingGame=true
ScreenShotName="UT2004Thumbnails.DMShots"
DecoTextName="XGame.Deathmatch"
MapListType="XInterface.MapListDeathMatch"

TimeLimit=0
bChangeLevels=false
Acronym="MI"
MapPrefix="DM"
GameName="MovieSandbox"
Description="Make your own movies"
}

