//-----------------------------------------------------------
//  Copyright 2006 Friedrich Kirschner
//-----------------------------------------------------------

class MSBScriptNodeButton extends MSBListButton; //MSBTwoStepTwoWayButton;

var MSBNodeOutButton NodeOut;

var MSBScriptTriggerNode Order;

var bool bDragged;
var bool rHasClickedAgain;
var bool bhideBranch;

var float xDist,yDist;

var array<string> Properties;

#exec texture Import File=Textures\Node.tga Name=Node_Icon Mips=Off Alpha=1

event PostBeginPlay()
{
Order=Spawn(class'MSBScriptTriggerNode');
NodeOut=Spawn(class'MSBNodeOutButton');
NodeOut.myScript=self;
super.PostBeginPlay();
M.LevelMSBScriptNodes[M.LevelMSBScriptNodes.length]=self;
}

function initButton(Canvas C)
{
if (bDragged)
  {
  xPos=Mouse.xPos+xDist;
  yPos=Mouse.yPos+yDist;
  }
C.FontScaleX=1;
C.FontScaleY=1;

super.initButton(C);

C.SetPos(xPos,yPos);

C.FontScaleX=buttonFontScale;
C.FontScaleY=buttonFontScale;

C.SetDrawColor(textCol.R,textCol.G,textCol.B);
C.DrawText(BtnName);
C.SetDrawColor(col.R,col.G,col.B);

C.FontScaleX=fontScale/1024 * C.ClipX;
C.FontScaleY=fontScale/1024 * C.ClipX;

if (bEnabled)
 {
 if (rHasClicked && Mouse.btnTwo)
   {
   rHasClickedAgain=true;
   RightBtnFinished(C);
   rHasClickedAgain=false;
   }
 }
}

function LeftBtn(Canvas C)
{
local int i;
super.LeftBtn(C);
for (i=0;i<Buttonlist.Length; i++)
  {
   MSBPropertyButton(ListButton[i]).Parent=self;
   MSBPropertyButton(ListButton[i]).Property=Properties[i];
  }
}

function RightBtn(Canvas C)
{
super.RightBtn(C);
bDragged=true;
xDist=xPos-Mouse.xPos;
yDist=yPos-Mouse.yPos;

}

function RightBtnFinished(Canvas C)
{
local int i;

rHasClicked=false;
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnTwo=false;
bDragged=false;
}

defaultproperties
{
Col=(R=200,G=255,B=200)

ButtonList[0]="MSBPropertyButtons.MSBPropertyButtonHideLinks";
Properties[0]="HideLinks";
ButtonList[1]="MSBPropertyButtons.MSBPropertyButtonShowLinks";
Properties[1]="ShowLinks";
ButtonList[2]="MSBPropertyButtons.MSBPropertyButtonText";
Properties[2]="BtnName";


widthRel=70
heightRel=18
Mat=Material'Node_Icon'
BtnName="ScriptRoot"
ypos=100
xpos=100
}

