//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBCreatePawn extends MSB3DSpawnButton;

#exec texture Import File=Textures\createVoxelPawn.tga Name=create_Block Mips=Off Alpha=1

function LeftBtnFinished(Canvas C)
{
local MSBNodeButton RootNodeBtn;
local MSBRootNode R;
local Pawn P;

P=Pawn(SpawnActor);
//Pawn Input Control
if (P.IsA('MSBPawn'))
  {
  MSBPawn(P).MSBPawnInputControl=Spawn(class'MSBPawnInputControl',P,,P.Location);
  MSBPawnInputControl(MSBPawn(P).MSBPawnInputControl).Mouse=Mouse;
  }

//Spawn a Button, a Root and a ScriptedController for our Pawn
RootNodeBtn=Spawn(class'MSBCode.MSBNodeButton',,,P.Location);
R=Spawn(class'MSBActions.MSBRootNode',,,P.Location);

//assign Order to MSBNodeButton
RootNodeBtn.Order=R;
RootNodeBtn.BtnName="PawnRoot";
RootNodeBtn.NodeIn.Destroy();
RootNodeBtn.Tag=P.Name;
RootNodeBtn.xPos=Mouse.xPos+40;
RootNodeBtn.yPos=Mouse.yPos+40;
RootNodeBtn.col.R=200;
RootNodeBtn.col.G=100;

//assign MSBPropertyButtons to RootMSBNodeButton
RootNodeBtn.ButtonList[0]="MSBPropertyButtons.MSBPropertyButtonHideLinks";
RootNodeBtn.Properties[0]="HideLinks";
RootNodeBtn.ButtonList[1]="MSBPropertyButtons.MSBPropertyButtonShowLinks";
RootNodeBtn.Properties[1]="ShowLinks";
RootNodeBtn.ButtonList[2]="MSBPropertyButtons.MSBPropertyButtonText";
RootNodeBtn.Properties[2]="BtnName";
RootNodeBtn.ButtonList[3]="MSBPropertyButtons.MSBPropertyButtonSetAnimSet";
RootNodeBtn.Properties[3]="SetAnim";
//RootNodeBtn.ButtonList[4]="MSBCode.MSBPropertyButtonSetSpeed";
//RootNodeBtn.Properties[4]="SetSpeed";


//setup MSBRootNode
R.BasePawn=P;
R.initialLocation=SpawnActor.Location;
R.initialRotation=SpawnActor.Rotation;
R.SelectText=string(P.Tag);

//setup Pawn and Order
P.ControllerClass=class'ScriptedController';
P.SetPhysics(PHYS_Falling);
super.LeftBtnFinished(C);
}

DefaultProperties
{
tooltip1="Spawn an Unreal Pawn"
tooltip2="Place UnrealPawn"
SpawnActorClassName="MSBObjects.MSBPawn"
floorOffset=(X=0,Y=0,Z=32)

Mat=Material'create_Block'
}
