//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBFullRig extends MSBPawn
config (BlockPawn);

var bool bCollision;
var float ColHeight, ColRadius;
var ShadowProjector PawnShadow;

var() vector ShadowDirection;
var() byte ShadowDarkness;
var() string MeshNameString;

simulated function PostBeginPlay()
{
Super.PostBeginPlay();
ColHeight=CollisionHeight;
ColRadius=CollisionRadius;
if(bShadowCast)
    {
	PawnShadow = Spawn(class'ShadowProjector',Self,'',Location);
	PawnShadow.ShadowActor = self;
	PawnShadow.RootMotion = True;
	PawnShadow.LightDirection = Normal(ShadowDirection);
	PawnShadow.LightDistance = 192;
	PawnShadow.MaxTraceDistance = 350;
	PawnShadow.InitShadow();
	PawnShadow.ShadowTexture.ShadowDarkness = ShadowDarkness;
    }
}

function Trigger(Actor Other, Pawn EventInstigator)
{
if (ColHeight!=0 && ColRadius!=0)
  {
  SetCollisionSize(ColRadius, ColHeight);
  SetCollision(true,false,false);
  }
}

simulated function destroyed()
{
local int i;

for (i=0;i<Attached.length;i++)
  Attached[i].Destroy();
}

DefaultProperties
{
Physics=Phys_None
bCollision=true;
bProjTarget=false;

mesh=SkeletalMesh'intro_malcom.Malcom'
Skins(0)=None
Skins(1)=None
DrawScale=0.5
ButtonList(6)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(6)="ColHeight"
ButtonList(7)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(7)="ColRadius"

maxBones=63

bPhysicsAnimUpdate=true
MovementAnims(0)=None
MovementAnims(1)=None
MovementAnims(2)=None
MovementAnims(3)=None
SwimAnims(0)=None
SwimAnims(1)=None
SwimAnims(2)=None
SwimAnims(3)=None
CrouchAnims(0)=None
CrouchAnims(1)=None
CrouchAnims(2)=None
CrouchAnims(3)=None
WalkAnims(0)=None
WalkAnims(1)=None
WalkAnims(2)=None
WalkAnims(3)=None
AirStillAnim=None
AirAnims(0)=None
AirAnims(1)=None
AirAnims(2)=None
AirAnims(3)=None
TakeoffStillAnim=None
TakeoffAnims(0)=None
TakeoffAnims(1)=None
TakeoffAnims(2)=None
TakeoffAnims(3)=None
LandAnims(0)=None
LandAnims(1)=None
LandAnims(2)=None
LandAnims(3)=None
DoubleJumpAnims(0)=None
DoubleJumpAnims(1)=None
DoubleJumpAnims(2)=None
DoubleJumpAnims(3)=None
DodgeAnims(0)=None
DodgeAnims(1)=None
DodgeAnims(2)=None
DodgeAnims(3)=None
WallDodgeAnims(0)=None
WallDodgeAnims(1)=None
WallDodgeAnims(2)=None
WallDodgeAnims(3)=None

TurnRightAnim=None
TurnLeftAnim=None
CrouchTurnRightAnim=None
CrouchTurnLeftAnim=None
IdleRestAnim=None
IdleCrouchAnim=None
IdleSwimAnim=None
IdleWeaponAnim=None
IdleHeavyAnim=None
IdleRifleAnim=None
IdleChatAnim=None
FireHeavyRapidAnim=None
FireHeavyBurstAnim=None
FireRifleRapidAnim=None
FireRifleBurstAnim=None
}
