//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonSavePartsList extends MSBPropertyButton;

var array<String> ButtonList;
var array<String> Properties;
var array<MSBGuiOverlay> ListButton;
var string saveName;

var int lastpage,maxButtons,maxListSize,currentpage;


function LeftBtn(Canvas C)
{
local int i;
super.LeftBtn(C);

if ((currentpage+1)*maxListSize<=M.SaveCharParts.length+1)
  maxButtons=(currentpage+1)*maxListSize;
else
  maxButtons=M.SaveCharParts.length+1;

for (i=currentpage*maxListSize;i<maxButtons; i++)
  {
    ListButton[i]=Spawn(class'MSBPropertyButtonText',self,,M.Location);
    ListButton[i].xPos=xpos+width;
     if (i>0)
      {                          //horizontal alignment
      ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+2;
      if (ListButton[i].yPos+ListButton[i].height>C.ClipY && ListButton[i].height<60)
        ListButton[i].ypos=yPos-(i*ListButton[i].height+height+2);
      }
    else
      ListButton[i].yPos=ypos;
    ListButton[i].SubLevel=SubLevel+1;
    MSBPropertyButton(ListButton[i]).Property="saveName";
    MSBPropertyButton(ListButton[i]).Parent=self;
    MSBPropertyButton(ListButton[i]).BtnName="createNew";
    if (i<M.SaveCharParts.length)
      MSBPropertyButton(ListButton[i]).BtnName=M.SaveCharParts[i];
  }


if (Buttonlist.length>maxListSize)
  {
  //create next/prev page buttons
  ListButton[i]=Spawn(class'MSBNextPageButton',self,,M.Location);
  MSBNextPageButton(ListButton[i]).Parent=self;
  ListButton[i].xPos=xpos+width;
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  ListButton[i].SubLevel=SubLevel+1;

  ListButton[++i]=Spawn(class'MSBPrevPageButton',self,,M.Location);
  MSBPrevPageButton(ListButton[i]).Parent=self;
  ListButton[i].xPos=xpos+width;
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  ListButton[i].SubLevel=SubLevel+1;
  }

LeftBtnFinished(C);
}

event Trigger(Actor Other,Pawn EventInstigator)
{
savePart(MSBMasterBlock(Parent),other);
Log("Triggered for saving...");
}

function MouseOver(Canvas C)
{
super.MouseOver(C);
C.SetPos(xpos+width,ypos);
if (Parent.IsA('MSBNodeButton'))
  C.DrawText(MSBNodeButton(Parent).Order.GetPropertyText(Property));
if (Parent.IsA('MSBPropertyButtonPad'))
  C.DrawText(MSBPawn(MSBPropertyButtonPad(Parent).Parent).PoseName[int(BtnName)-1]);

}


event savePart(MSBMasterBlock Master, actor Other)
{
local MSBBlockCloud cloud;
local int i;

cloud=Level.Game.CreateDataObject(class'MSBBlockCloud',saveName,"CharacterParts");
for (i=0;i<Master.S.length;i++)
  {
  cloud.BlockRelLocation[i]=Master.S[i].RelativeLocation << Master.Rotation;
  Log(Master.S[i].RelativeLocation);
  cloud.Col[i]=ColorModifier(Master.S[i].Skins[0]).Color;
  cloud.drawScale[i]=Master.S[i].DrawScale;
  if (Master.S[i].shader!=None)
    cloud.blockShader[i]=String(Master.S[i].shader.Class);
  else
    cloud.blockShader[i]="";
  }
Level.Game.SavePackage("CharacterParts");
//update SaveParts List
for (i=0;i<ListButton.Length;i++)
  if (Other==ListButton[i] && i< ListButton.Length)
    M.SaveCharParts[i]=saveName;

M.SaveGeneralConfig();
}

DefaultProperties
{
//width=32
Col=(R=128,G=64,B=64)
maxListSize=10
}
