class MSBPropertyButtonTraceTexture extends MSBPropertyButtonText;

#exec texture Import File=Textures\UpperArm.dds Name=Arm Mips=Off Alpha=1


var MSBVoxelEdController CC;
var TexScaler TraceMat;
var Material BaseMat;
var() float uDist,vDist,myScale;

function LeftBtnFinished(Canvas C)
{
local int i;
local vector xAxis,yAxis,zAxis;
local MSBMasterBLock Master;

CC=MSBVoxelEdController(M);
Master=CC.DrawBrush.Master;

Master.GetAxes(Master.Rotation,xAxis,yAxis,zAxis);

for (i=0;i<Master.S.length;i++)
  {
  uDist=Master.S[i].RelativeLocation dot xAxis;
  vDist=Master.S[i].RelativeLocation dot zAxis;

  Log("uDistance of Block"@i@":"@uDist);
//  vDist+=4;

  TraceMat=new class'TexScaler';
  TraceMat.Material=BaseMat;
  TraceMat.UScale=myScale;
  TraceMat.VScale=myScale;
  TraceMat.UOffset=(uDist * (512/myScale))*2;
  TraceMat.VOffset=-2*(vDist * (512/myScale))-256;

  ColorModifier(Master.S[i].Skins[0]).Material=TraceMat;

  ColorModifier(Master.S[i].Skins[0]).Color.R=255;
  ColorModifier(Master.S[i].Skins[0]).Color.G=255;
  ColorModifier(Master.S[i].Skins[0]).Color.B=255;
  ColorModifier(Master.S[i].Skins[0]).Color.A=255;

  Master.S[i].Texture=TraceMat;
  Log("Texture:"@Master.S[i].Texture);
  }

super.LeftBtnFinished(C);
}


defaultproperties
{
BaseMat=Arm
myScale=28
}
